diff --git a/bin/varnishd/cache/cache_ban_build.c b/bin/varnishd/cache/cache_ban_build.c
index 28376f56c2..2e6f078891 100644
--- a/bin/varnishd/cache/cache_ban_build.c
+++ b/bin/varnishd/cache/cache_ban_build.c
@@ -29,7 +29,7 @@
  * SUCH DAMAGE.
  *
  */
-
+#include <stdio.h>
 #include "config.h"
 
 #include <stdlib.h>
@@ -246,7 +246,7 @@ BAN_AddTest(struct ban_proto *bp,
 		return (bp->err);
 
 	for (pv = pvars; pv->name != NULL; pv++)
-		if (!strncmp(a1, pv->name, strlen(pv->name)))
+		if (!strncmp(a1, pv->name, pv->flag & BANS_FLAG_HTTP ? strlen(pv->name) : strlen(a1)))
 			break;
 
 	if (pv->name == NULL)
